<?php
defined('BASEPATH') or exit('No direct script access allowed');
class Invoice extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->database();
        $this->load->library('session');
        $this->load->model('General_model');
        $this->load->model('InvoiceModel');
        $this->load->database();
    }
    public function index()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/invoice/index', $data);
        $this->load->view('admin/controller/footer');
    }
    public function product_id()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";

        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/product_id', $data);
        $this->load->view('admin/controller/footer');
    }
    public function get_addfrm()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $data["customer"] = $this->General_model->get_data('customer', 'status', '*', '1');

        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');
        $data["challan"] = $this->db->query("select * from sale where invoice_generated='1' and status='1'")->result();
        $data["invoice_no"] = $this->InvoiceModel->invoice_no();

        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/invoice/create', $data);
        $this->load->view('admin/controller/footer');
    }
    public function create()
    {

        $this->General_model->auth_check();

        $date = $this->input->post("date");
        $date = explode("/", $date);
        $date = [$date[2], $date[1], $date[0]];
        $date = implode("-", $date);

        $customer_id = $this->input->post("customer_id");
        $type = $this->input->post("type");
        $customer_name = $this->db->query("select name from customer where id_customer='$customer_id'")->row()->name;

        $invoice_no = $this->input->post("invoice_no");
        $sale_id = $this->input->post("sale_id");
        $total = 0;
        foreach ($this->input->post("sale_id") as $pr) {
            $total1 = $this->db->query("select sum(g_total) as total from sale where id_sale=$pr")->row()->total;

            $total = $total + $total1;
        }
        if (isset($date) && !empty($date)  &&  isset($invoice_no) && !empty($invoice_no)) {
            $i = 0;
            $sale = [
                'date' => $date,
                'invoice_no' => $invoice_no,
                'customer_name' => $customer_name,
                'customer_id' => $customer_id,
                'type' => $type,
                'total' => $total,
                'date_created' => date("Y-m-d h:i:s")
            ];
            $id = $this->General_model->addid('invoice', $sale);

            foreach ($this->input->post("sale_id") as $pr) {

                $total1 = $this->db->query("select sum(g_total) as total from sale where id_sale=$pr")->row()->total;
                $sale_id = $this->input->post("sale_id")[$i];
                if (!empty($sale_id) && !empty($sale_id)) {
                    $product = [
                        'invoice_id' => $id,
                        'challan_no' => $sale_id,
                        'total' => $total1
                    ];
                    $this->db->insert('invoice_product', $product);

                    $this->db->query("UPDATE `sale` SET `invoice_generated` = '1' WHERE `sale`.`id_sale` = $sale_id");
                }
                $i++;
            }

            $sess_data = [
                'status'  => 'success',
                'msg'  => 'Invoice Added'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Invoice'));
        } else {
            $sess_data = [
                'status'  => 'error',
                'msg'  => 'Something Is Worng'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Invoice'));
        }
    }
    public function getLists()
    {
        $columns = array(
            0 => 'id',
            1 => 'invoice_no',
            2 => 'date',
            3 => 'customer_name',
            4 => 'g_total'
        );
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->InvoiceModel->allposts_count();
        $totalFiltered = $totalData;
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->InvoiceModel->allposts($limit, $start, $order, $dir);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->InvoiceModel->posts_search($limit, $start, $search, $order, $dir);
            $totalFiltered = $this->InvoiceModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->total, 2);
                $nestedData['button'] = '
		        <a href="' . base_url('Invoice/view/') . $post->id . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-clipboard" aria-hidden="true"></i></button></a>
		        
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getLists1($id)
    {
        $columns = array(
            0 => 'id',
            1 => 'date',
            3 => 'price',
            4 => 'qty',
            5 => 'total',
            6 => 'gtotal',
        );

        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->InvoiceModel->allposts_count1($id);
        $totalFiltered = $totalData;
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->InvoiceModel->allposts1($limit, $start, $order, $dir, $id);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->InvoiceModel->posts_search($limit, $start, $search, $order, $dir);
            $totalFiltered = $this->InvoiceModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $nestedData['sr_no'] = $post->invoice_no;
                $nestedData['product_name'] = $post->product_name;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['price'] = $post->price;
                $nestedData['qty'] = $post->qty;
                $nestedData['total'] = number_format($post->total, 2);
                $nestedData['gtotal'] = number_format($post->gtotal, 2);
                $nestedData['button'] = '
		        <a href="' . base_url('Sale/get_editfrm/') . $post->sale_id . '"><button type="button" class="btn btn-primary btn-sm waves-effect waves-light"><i class="fa fa-edit" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Invoice/') . $post->sale_id . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->sale_id . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getLists2($id)
    {
        $columns = array(
            0 => 'id ',
            1 => 'bill_type',
            2 => 'invoice_no',
            3 => 'date',
            4 => 'customer_name',
            5 => 'g_total',
            6 => 'jama',
            7 => 'baki',
        );
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->InvoiceModel->allposts_count();
        $totalFiltered = $totalData;
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->InvoiceModel->allposts2($limit, $start, $order, $dir, $id);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->InvoiceModel->posts_search($limit, $start, $search, $order, $dir);
            $totalFiltered = $this->InvoiceModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $bill_type = (($post->bill_type == "1") ? "Cash" : "Debit");
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['bill_type'] = $bill_type;
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['jama'] = number_format($post->jama, 2);
                $nestedData['baki'] = number_format($post->baki, 2);
                $nestedData['button'] = '
		        <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-primary btn-sm waves-effect waves-light"><i class="fa fa-edit" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Invoice/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function get_editfrm($id)
    {
        $this->General_model->auth_check();
        $data["customer"] = $this->General_model->get_all('customer');
        $data['sale'] = $this->General_model->get_row('sale', 'id_sale', $id);
        $sale_product = $this->General_model->get_data('sale_product', 'sale_id', '*', $id);
        $i = 1;
        foreach ($sale_product as $key => $value) {
            if ($i == 1) {
                $produtids[] = "product_id != '" . $value->product_id . "'";
            } else {
                $produtids[] = "and product_id != '" . $value->product_id . "'";
            }
            $i++;
        }
        $notselect_id = implode(" ", $produtids);
        //	$data["product"]=$this->db->query("SELECT * FROM `product` WHERE ".$notselect_id)->result(); 
        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');

        $data['sale_product'] = $this->db->query("SELECT t1.*,t2.product_name,t2.qty as product_qty,(t1.qty+t2.qty) as total_qty  FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'")->result();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/edit', $data);
        $this->load->view('admin/controller/footer');
    }
    public function update()
    {
        $this->General_model->auth_check();
        $this->General_model->auth_check();
        $date = $this->input->post("date");
        $date = explode("/", $date);
        $date = [$date[2], $date[1], $date[0]];
        $date = implode("-", $date);
        $id_sale = $this->input->post("id_sale");
        $bill_type = $this->input->post("bill_type");
        $customer_name = (($bill_type == "1")
            ? trim(ucwords($this->input->post("customer_name")))
            : NULL);
        $remark = trim(ucwords($this->input->post("remark")));
        $remark = ((isset($remark) && !empty($remark))
            ? $remark
            : NULL);
        $customer_id = (($bill_type == "2")
            ? $this->input->post("customer_id")
            : NULL);
        $jama_rs = (($bill_type == "2")
            ? $this->input->post("jama")
            : NULL);
        $baki_rs = (($bill_type == "2")
            ? $this->input->post("baki")
            : NULL);
        $g_total = $this->input->post("g_total");
        if (isset($date) && !empty($date) && isset($bill_type) && !empty($bill_type) &&  isset($g_total) && !empty($g_total) && isset($id_sale) && !empty($id_sale)) {
            $sale = [
                'bill_type' => $bill_type,
                'date' => $date,
                'customer_name' => $customer_name,
                'customer_id' => $customer_id,
                'g_total' => $g_total,
                'remark' => $remark,
                'jama' => $jama_rs,
                'baki' => $baki_rs
            ];
            $this->General_model->update('sale', $sale, 'id_sale', $id_sale);
            if ($bill_type == "2") {
                $sale_payment = [
                    'bill_type' => $bill_type,
                    'date' => $date,
                    'customer_id' => $customer_id,
                    'g_total' => $g_total,
                    'remark' => $remark,
                    'rs' => $jama_rs,
                    'baki' => $baki_rs
                ];
                $this->General_model->update('sale_payment', $sale_payment, 'sale_id', $id_sale);
            }
            $i = 0;
            foreach ($this->input->post("product_id") as $pr) {
                $product_id = $this->input->post("product_id")[$i];
                $quantity = $this->input->post("quantity")[$i];
                $price = $this->input->post("item_price")[$i];
                $id_saleproduct = $this->input->post("id_sale_product")[$i];
                $extra_price = $this->input->post("item_price_extra")[$i];
                $total = $this->input->post("total")[$i];
                $discount = $this->input->post("discount")[$i];
                $gtotal = $this->input->post("gtotal")[$i];
                if (isset($id_saleproduct) && !empty($id_saleproduct) && !empty($quantity) && !empty($price)) {
                    $sale_product = $this->General_model->get_row('sale_product', 'id_saleproduct', $id_saleproduct);
                    $prouctQty = $this->General_model->get_row('product', 'product_id', $product_id);
                    $product_qty = $prouctQty->qty - $sale_product->qty;
                    $product_qty = $product_qty + $quantity;
                    $this->General_model->update('product', ['qty' => $product_qty], 'product_id', $product_id);
                    $product = [
                        'product_id' => $product_id,
                        'qty' => $quantity,
                        'extra_price' => $extra_price,
                        'price' => $price,
                        'total' => $total,
                        'discount' => $discount,
                        'gtotal' => $gtotal
                    ];
                    $this->General_model->update('sale_product', $product, 'id_saleproduct', $id_saleproduct);
                } else {
                    $prouctQty = $this->General_model->get_row('product', 'product_id', $product_id);
                    $product_qty = $prouctQty->qty;
                    $product_qty = $product_qty - $quantity;
                    $this->General_model->update('product', ['qty' => $product_qty], 'product_id', $product_id);
                    $product = [
                        'sale_id' => $id_sale,
                        'product_id' => $product_id,
                        'qty' => $quantity,
                        'extra_price' => $extra_price,
                        'price' => $price,
                        'total' => $total,
                        'discount' => $discount,
                        'gtotal' => $gtotal,
                        'created_at' => date("Y-m-d h:i:s")
                    ];
                    $this->db->insert('sale_product', $product);
                }
                $i++;
            }
            $sess_data = [
                'status'  => 'success',
                'msg'  => 'Sale updated'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        } else {
            $sess_data = [
                'status'  => 'error',
                'msg'  => 'Something Is Worng'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        }
    }
    public function Slip($id)
    {
        $data['page_title'] = "Invoice";
        $data['sale'] = $this->db->query("SELECT t1.*,t2.name as customer_name2 FROM sale as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id_sale='" . $id . "'")->row();
        $data['cutting_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "' and t1.cutting_molding=1")->result();
        $data['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'  and t1.cutting_molding=0")->result();
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/invoice', $data);
        $this->load->view('admin/controller/footer');
    }

    public function Challan($id)
    {
        $data['page_title'] = "Invoice";
        $data['sale'] = $this->db->query("SELECT t1.*,t2.name as customer_name2 FROM sale as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id_sale='" . $id . "'")->row();
        $data['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'  and t1.cutting_molding=1")->result();
        $data['molding_sale_other_product'] = $this->db->query("SELECT * FROM sale_other_product WHERE sale_id='" . $id . "' ")->result();
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/challan', $data);
        $this->load->view('admin/controller/footer');
    }

    public function view($id)
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Invoice";
        $data['invoice'] = $this->db->query("SELECT t1.*,t2.name as customer_name2,t2.address as customer_address FROM invoice as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id='" . $id . "'")->row();
        $challan_no = $this->db->query("select challan_no from invoice_product where invoice_id=" . $id . "")->result();

        $i = 0;
        $o_charge = 0;
        $data['cutting_sale_product']  =  [];
        $data['molding_sale_product']  =  [];
        $data['molding_sale_other_product'] =  [];
        foreach ($challan_no as $key => $challan) {
            $localtranport = $this->General_model->get_row('sale','id_sale',$challan->challan_no);
            $o_charge = $o_charge + $localtranport->other_charge;
            $datacut[$key]['cutting_sale_product']  = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $challan->challan_no . "' and t1.cutting_molding=0")->result();

            $datacut[$key]['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $challan->challan_no . "'  and t1.cutting_molding=1")->result();
            $datacut[$key]['molding_sale_other_product'] = $this->db->query("SELECT * FROM sale_other_product WHERE sale_id='" . $challan->challan_no . "' ")->result();
            $data['cutting_sale_product']  = array_merge($data['cutting_sale_product'], $datacut[$key]['cutting_sale_product']);
            $data['molding_sale_product'] = array_merge($data['molding_sale_product'], $datacut[$key]['molding_sale_product']);
            $data['molding_sale_other_product']  = array_merge($data['molding_sale_other_product'], $datacut[$key]['molding_sale_other_product']);
            $i++;
        }
            $data['other_charge'] = $o_charge;
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/invoice/view', $data);
        $this->load->view('admin/controller/footer');
    }

    public function delete($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $sale_product = $this->General_model->get_data('invoice_product', 'invoice_id', '*', $id);
            foreach ($sale_product as $key => $value) {
                $prouctQty = $this->General_model->get_row('sale', 'id_sale', $value->challan_no);
                $this->General_model->update('sale', ['invoice_generated' => 0], 'id_sale', $value->challan_no);
            }
            $this->General_model->delete('invoice', 'id', $id);
            $this->General_model->delete('invoice_product', 'invoice_id', $id);
            $data['status'] = "success";
            $data['msg'] = "Purchase Detail Deleted";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function deleterow($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $sale_product = $this->General_model->get_data('sale_product', 'id_saleproduct', '*', $id);
            foreach ($sale_product as $key => $value) {
                $prouctQty = $this->General_model->get_row('product', 'product_id', $value->product_id);
                $product_qty = $prouctQty->qty;
                $product_qty = $product_qty + $value->qty;
                $this->General_model->update('product', ['qty' => $product_qty], 'product_id', $value->product_id);
            }
            $this->General_model->delete('sale_product', 'id_saleproduct', $id);
            $data['status'] = "success";
            $data['msg'] = "Purchase Detail Deleted";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
}
