<?php
defined('BASEPATH') or exit('No direct script access allowed');
class  Stock extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->helper('url');
		$this->load->database();
		$this->load->library('session');
		$this->load->model('General_model');
		$this->load->model('StockModel');
		$this->load->model('StockUserModel');
		$this->load->model('LogModel');
		$this->General_model->auth_check();
		$this->General_model->auth_role2();
	}
	public function index()
	{
		$this->General_model->auth_check();
		$data['page_title'] = "Stock";
		$this->load->view('admin/controller/header');
		$this->load->view('admin/controller/sidebar');
		$this->load->view('admin/stock/index', $data);
		$this->load->view('admin/controller/footer');
	}
	public function get_addfrm()
	{
		$this->General_model->auth_check();
		$data['page_title'] = "Stock";
		$data['party'] = $this->General_model->get_data('party', 'status', '*', '1');
		$data['transport'] = $this->General_model->get_data('transport', 'status', '*', '1');
		$invoice_no = $this->db->query("select * from stock where status=1 ORDER BY order_no desc LIMIT 1")->row();
		$data['order_no'] = (empty($invoice_no)) ? "1" : $invoice_no->order_no + 1;

		$this->load->view('admin/controller/header');
		$this->load->view('admin/controller/sidebar');
		$this->load->view('admin/stock/create', $data);
		$this->load->view('admin/controller/footer');
	}
	public function create()
	{
		$this->General_model->auth_check();
		$party = trim($this->input->post("party"));
		$transport = trim($this->input->post("transport"));
		$date = explode('/', $this->input->post('date'));
		$date = [$date[2], $date[1], $date[0]];
		$date = implode("-", $date);
		$order_no = trim($this->input->post("order_no"));
		$order_no = str_replace(" ", "", $order_no);
		$order_no = str_replace(".", "-", $order_no);
		$t_bala = trim($this->input->post("t_bala"));
		$t_mtr = trim($this->input->post("t_mtr"));
		if (isset($party) && !empty($party) && isset($order_no) && !empty($order_no)  && isset($date) && !empty($date)) {
			$partydetail = $this->General_model->get_row('party', 'party_id', $party);
			$detail = [
				'party_id' => $party,
				'order_no' => $order_no,
				'date' => $date,
				'mobile' => $partydetail->mobile_number,
				'gst_no' => $partydetail->gst_number,
				'pan_no' => $partydetail->pan_number,
				'transport_id' => $transport,
				'user_id' => $_SESSION['auth_user_id'],
				'status' => '1',
				'created_at' => date("Y-m-d h:i:s")
			];
			$stock = $this->General_model->addid('stock', $detail);
			$i = 0;
			$msg = "Stock insert id " . $stock;
			$this->LogModel->simplelog($msg);

			foreach ($this->input->post('design_no') as $lt) {
				$design_no = $this->input->post('design_no')[$i];
				$shade_no = $this->input->post('shade_no')[$i];
				$s_26 = $this->input->post('26')[$i];
				$s_28 = $this->input->post('28')[$i];
				$s_30 = $this->input->post('30')[$i];
				$s_32 = $this->input->post('32')[$i];
				$s_34 = $this->input->post('34')[$i];
				$s_36 = $this->input->post('36')[$i];
				$s_38 = $this->input->post('38')[$i];
				$s_40 = $this->input->post('40')[$i];
				$s_42 = $this->input->post('42')[$i];
				$s_44 = $this->input->post('44')[$i];
				$s_46 = $this->input->post('46')[$i];
				$s_48 = $this->input->post('48')[$i];
				$stock_product = [
					'stock_id' => $stock,
					'design_no' => $design_no,
					'shade_no' => $shade_no,
					's_26' => $s_26,
					's_28' => $s_28,
					's_30' => $s_30,
					's_32' => $s_32,
					's_34' => $s_34,
					's_36' => $s_36,
					's_38' => $s_38,
					's_40' => $s_40,
					's_42' => $s_42,
					's_44' => $s_44,
					's_46' => $s_46,
					's_48' => $s_48,
					'created_at' => date('Y/m/d H:m:i'),
					'status' => '1'
				];
				$this->General_model->add('stock_product', $stock_product);

				$i++;
			}
			$sess_data = [
				'status'  => 'success',
				'msg'  => 'Stock Added'
			];
			$this->session->set_userdata($sess_data);
			redirect('Stock/view_invoice/' . $stock);
		} else {
			$sess_data = [
				'status'  => 'error',
				'msg'  => 'Something Is Worng'
			];
			$this->session->set_userdata($sess_data);
			redirect('Stock/get_addfrm/');
		}
	}
	public function getListsadmin()
	{
		$columns = array(
			0 => 'stock_id',
			1 => 'date',
			2 => 'party_name',
			3 => 'item_name',
			4 => 'order_no',
			5 => 'total_meter',
			6 => 'transport_name',
			7 => 'user_name'
		);
		$limit = $this->input->post('length');
		$start = $this->input->post('start');
		$order = $columns[$this->input->post('order')[0]['column']];
		$dir = $this->input->post('order')[0]['dir'];
		$totalData = $this->StockModel->allposts_count();
		$totalFiltered = $totalData;
		if (empty($this->input->post('search')['value'])) {
			$posts = $this->StockModel->allposts($limit, $start, $order, $dir);
		} else {
			$search = $this->input->post('search')['value'];
			$posts =  $this->StockModel->posts_search($limit, $start, $search, $order, $dir);
			$totalFiltered = $this->StockModel->posts_search_count($search);
		}
		$data = array();
		if (!empty($posts)) {
			$i = 1;
			foreach ($posts as $post) {
				if ($_SESSION['auth_role_id'] == "1") {
					$button = '<a href="' . base_url('Stock/view_invoice/') . $post->stock_id . '"><button type="button" class="btn btn-custom btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        		<button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->stock_id . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
				} else {
					$button = '<a href="' . base_url('Stock/view_invoice/') . $post->stock_id . '"><button type="button" class="btn btn-custom btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>';
				}
				$nestedData['sr_no'] = $i;
				$nestedData['date'] = date('d/m/Y', strtotime($post->date));
				$nestedData['party_name'] = $post->party_name;
				$nestedData['order_no'] = $post->order_no;
				$nestedData['transport_name'] = $post->transport_name;
				$nestedData['user_name'] = strtoupper($post->user_name);
				$nestedData['button'] = $button;
				$data[] = $nestedData;
				$i++;
			}
		}
		$json_data = array(
			"draw"            => intval($this->input->post('draw')),
			"recordsTotal"    => intval($totalData),
			"recordsFiltered" => intval($totalFiltered),
			"data"            => $data
		);
		echo json_encode($json_data);
	}
	public function getLists()
	{
		$columns = array(
			0 => 'stock_id',
			1 => 'date',
			2 => 'party_name',
			3 => 'item_name',
			4 => 'order_no',
			5 => 'total_meter',
			6 => 'transport_name',
			7 => 'user_name'
		);
		$limit = $this->input->post('length');
		$start = $this->input->post('start');
		$order = $columns[$this->input->post('order')[0]['column']];
		$dir = $this->input->post('order')[0]['dir'];
		$totalData = $this->StockUserModel->allposts_count();
		$userid = $_SESSION['auth_user_id'];
		$totalFiltered = $totalData;
		if (empty($this->input->post('search')['value'])) {
			$posts = $this->StockUserModel->allposts($limit, $start, $order, $dir, $userid);
		} else {
			$search = $this->input->post('search')['value'];
			$posts =  $this->StockUserModel->posts_search($limit, $start, $search, $order, $dir, $userid);
			$totalFiltered = $this->StockUserModel->posts_search_count($search);
		}
		$data = array();
		if (!empty($posts)) {
			$i = 1;
			foreach ($posts as $post) {
				if ($_SESSION['auth_role_id'] == "1") {
					$button = '<a href="' . base_url('Stock/view_invoice/') . $post->stock_id . '"><button type="button" class="btn btn-custom btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        		<button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->stock_id . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
				} else {
					$button = '<a href="' . base_url('Stock/view_invoice/') . $post->stock_id . '"><button type="button" class="btn btn-custom btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>';
				}
				$nestedData['sr_no'] = $i;
				$nestedData['date'] = date('d/m/Y', strtotime($post->date));
				$nestedData['party_name'] = $post->party_name;
				$nestedData['order_no'] = $post->order_no;
				$nestedData['transport_name'] = $post->transport_name;
				$nestedData['user_name'] = strtoupper($post->user_name);
				$nestedData['button'] = $button;
				$data[] = $nestedData;
				$i++;
			}
		}
		$json_data = array(
			"draw"            => intval($this->input->post('draw')),
			"recordsTotal"    => intval($totalData),
			"recordsFiltered" => intval($totalFiltered),
			"data"            => $data
		);
		echo json_encode($json_data);
	}
	public function get_editfrm($id)
	{
	}
	public function update()
	{
	}
	public function view_invoice($id)
	{
		$data['page_title'] = "Stock";
		$data['stock'] = $this->db->query("SELECT t1.*,t2.party_name,t3.transport_name FROM stock as t1 LEFT JOIN party as t2 ON t1.party_id = t2.party_id LEFT JOIN transport as t3 ON t1.transport_id = t3.transport_id  WHERE stock_id='" . $id . "'")->row();
		$data['stockdetail'] = $this->General_model->get_data('stock_product', 'stock_id', '*', $id);
		$this->load->view('admin/controller/header');
		$this->load->view('admin/controller/sidebar');
		$this->load->view('admin/stock/invoice', $data);
		$this->load->view('admin/controller/footer');
	}
	public function delete($id)
	{
		$this->General_model->auth_check();
		if (isset($id) && !empty($id)) {
			$i = 0;
			$msg = "Stock Deleted " . $id;
			$this->LogModel->simplelog($msg);
			$detail = $this->General_model->delete('stock', 'stock_id', $id);
			$detail = $this->General_model->delete('stock_product', 'stock_id', $id);
			$data['status'] = "success";
			$data['msg'] = "Stock Deleted";
		} else {
			$data['status'] = "error";
			$data['msg'] = "Something is Worng";
		}
		echo json_encode($data);
	}
	public function check_order()
	{
		$this->General_model->auth_check();
		$party = $this->input->post('party');
		$order_no = trim($this->input->post('order_no'));
		$order_no = str_replace(" ", "", $order_no);
		$order_no = str_replace(".", "-", $order_no);
		if (isset($party) && !empty($party) && isset($order_no) && !empty($order_no)) {
			$check_order = $this->db->query("SELECT * FROM `stock` WHERE party_id='" . $party . "' and order_no LIKE '" . $order_no . "'")->num_rows();
			if ($check_order > 0) {
				$data['status'] = "error";
				$data['msg'] = "Party's order Number Already Exist";
			} else {
				$data['status'] = "success";
			}
		} else {
			$data['status'] = "error";
			$data['msg'] = "Something is Worng";
		}
		echo json_encode($data);
	}
}
