<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <div class="page-title-box">
                    <h4 class="page-title float-left"><?php echo $page_title; ?></h4>
                    <ol class="breadcrumb float-right">
                        <li class="breadcrumb-item"><a href="<?php echo base_url('Dashbord'); ?>"><?php echo COMPANY; ?></a></li>
                        <li class="breadcrumb-item"><a href="<?php echo base_url('Product/index'); ?>"><?php echo $page_title; ?></a></li>
                    </ol>
                    <div class="clearfix"></div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <div class="card-box table-responsive">
                    <table id="datatable-buttons" class="table table-striped table-bordered text-center" cellspacing="0" width="100%">
                        <thead>
                            <tr>
                                <th>#</th>
                                <th>Invoice No</th>
                                <th>Date</th>
                                <th>Customer Name</th>
                                <th>G Total</th>
                                <th>Unit</th>
                                <th>order status</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function() {
        var table = $('#datatable-buttons').DataTable({
            processing: true,
            serverSide: true,
            order: [],
            ajax: {
                "url": "<?php echo base_url('Sale/getLists/2023'); ?>",
                "type": "POST"
            },
            "order": [
                [0, "DESC"]
            ],
            columns: [{
                    "data": "sr_no"
                },
                {
                    "data": "invoice_no"
                },
                {
                    "data": "date"
                },
                {
                    "data": "customer_name"
                },
                {
                    "data": "g_total"
                },
                {
                    "data": "unit"
                },
                {
                    "data": "order_status"
                },
                {
                    "data": "button"
                },
            ],
            columnDefs: [{
                "targets": [7],
                "orderable": false
            }],
            buttons: ['print', 'copy', 'excel', 'colvis'],
            lengthMenu: [[10, 25, 50, -1], [10, 25, 50, "All"]],
            dom: 'Blfrtip'
        });
        $('#datatable-buttons').on('click', '[data-id=delete]', function() {
            var id = $(this).data("value");
            swal({
                title: 'Are you sure delete?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#4fa7f3',
                cancelButtonColor: '#d57171',
                confirmButtonText: 'Yes, delete it!'
            }).then(function() {
                $.ajax({
                    type: "POST",
                    url: "<?php echo base_url('sale/delete/'); ?>" + id + "",
                    success: function(data) {
                        var data = JSON.parse(data);
                        if (data.status == "success") {
                            swal("success", data.message, "success", "#4fa7f3");
                            table.ajax.reload();
                        } else {
                            swal("error", data.message, "warning", "#4fa7f3");
                        }
                    }
                });
            })
        });
    });
</script>