<?php
defined('BASEPATH') or exit('No direct script access allowed');
class  Product extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->database();
        $this->load->library('session');
        $this->load->model('General_model');
        $this->load->model('Genral_datatable');
        $this->load->database();
    }
    public function index()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Product";
        $data["method"] = "add";
        $data['frm_id'] = "Add_frm";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/setting/product', $data);
        $this->load->view('admin/controller/footer');
    }
    public function create()
    {
        $this->General_model->auth_check();
        $name = ucwords(trim($this->input->post("name")));
        $unit = ucwords(trim($this->input->post("unit")));
        $price = ucwords(trim($this->input->post("price")));
        $type = $this->input->post("type");
        if (isset($name) && !empty($name)  && isset($price) && !empty($price)) {
            $count = $this->General_model->has_duplicate($name, 'product', 'product_name');
            if ($count > 0) {
                $data['status'] = "error";
                $data['msg'] = "Product Already Exist";
            } else {
                $detail = [
                    'product_name' => $name,
                    'price' => $price,
                    'type' => $type,
                    'hsn_code' => NULL,
                    'unit' => $unit,
                    'status' => '1',
                    'created_at' => date("Y-m-d h:i:s")
                ];
                $detail = $this->db->insert('product', $detail);
                $data['status'] = "success";
                $data['msg'] = "Product Added";
            }
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    function getLists()
    {
        $this->General_model->auth_check();
        $table = 'product';
        $order_column_array = array('product_id', 'unit', 'price', 'qty', 'product_name', 'status');
        $search_order = array('product_id', 'product_name', 'qty', 'price');
        $order_by_array = array('product_id' => 'DESC');
        $data = $row = array();
        $Master_Data = $this->Genral_datatable->getRows($_POST, $table, $order_column_array, $search_order, $order_by_array);
        $i = $_POST['start'];
        foreach ($Master_Data as $m_data) {
            $qty = ((isset($m_data->qty) && !empty($m_data->qty)) ? $m_data->qty : 0);
            $qty = (($qty <= 5) ? '<span class="p-1 px-3 primary text-bold">' . $qty . '</span>'
                : '<span class="p-1 px-3 text-primary">' . $qty . '</span>'
            );
            $i++;
            $data[] =     [
                $i,
                $m_data->product_name,
                number_format($m_data->price, 1),
                $m_data->unit,
                '<a href="' . base_url('Product/get_editfrm/') . $m_data->product_id . '"><button type="button" class="btn btn-custom waves-effect waves-light btn-sm"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button></a>
	    		<button type="button" class="btn btn-danger waves-effect waves-light" data-id="delete" data-value="' . $m_data->product_id  . '"><i class="fa fa-trash" aria-hidden="true"></i></button>			'
            ];
        }
        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal" => $this->Genral_datatable->countAll($table),
            "recordsFiltered" => $this->Genral_datatable->countFiltered($_POST, $table, $order_column_array, $search_order, $order_by_array),
            "data" => $data,
        );
        echo json_encode($output);
    }
    public function get_editfrm($id)
    {
        $this->General_model->auth_check();
        $data['method'] = "edit";
        $data['frm_id'] = "Edit_frm";
        $data['page_title'] = "Product";
        $data['result'] = $this->General_model->get_row('product', 'product_id', $id);
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/setting/product', $data);
        $this->load->view('admin/controller/footer');
    }
    public function update()
    {
        $this->General_model->auth_check();
        $name = $this->input->post("name");
        $type = $this->input->post("type");
        $status = $this->input->post("status");
        $id = $this->input->post("id");
        $price = ucwords(trim($this->input->post("price")));
        $unit = ucwords(trim($this->input->post("unit")));
        if (isset($name) && !empty($name) && isset($id) && !empty($id) && isset($price) && !empty($price)) {
            $count = $this->General_model->has_duplicate_query("select product_name from product where product_name ='" . $name . "' and product_id !='" . $id . "'");
            if ($count > 0) {
                $data['status'] = "error";
                $data['msg'] = "Product Already Exist";
            } else {
                $detail = [
                    'product_name' => $name,
                    'price' => $price,
                    'type' => $type,
                    'hsn_code' => NULL,
                    'unit' => $unit,
                    'status' => $status,
                ];
                $this->General_model->update('product', $detail, 'product_id', $id);
                $data['status'] = "success";
                $data['msg'] = "Product Updated";
            }
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function delete($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $detail = $this->General_model->delete('product', 'product_id', $id);
            $data['status'] = "success";
            $data['msg'] = "product  Deleted";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function get_qty($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $product = $this->General_model->get_row('product', 'product_id', $id);
            $data['price'] = $product->price;
            $data['type'] = $product->type;
            $data['status'] = "success";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function get_qty_sell_purchase($id)
    {
        $sale_qty = $this->db->query("select sum(qty) as total_sale from sale_product where product_id=" . $id . "")->row()->total_sale;
        $purchase_qty = $this->db->query("select sum(qty) as total_purchase from purchase_product where product_id=" . $id . "")->row()->total_purchase;

        echo $sale_qty . "###" . $purchase_qty;
    }
}
