<?php
defined('BASEPATH') or exit('No direct script access allowed');
class  Sale extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('url');
        $this->load->database();
        $this->load->library('session');
        $this->load->model('General_model');
        $this->load->model('SaleModel');
        $this->load->model('PurchaseModel');
        $this->load->database();
    }
    
    public function index()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/index', $data);
        $this->load->view('admin/controller/footer');
    }
    public function old_2023()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/index_old', $data);
        $this->load->view('admin/controller/footer');
    }
    public function pending()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/pending', $data);
        $this->load->view('admin/controller/footer');
    }
    public function confirm()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/confirm', $data);
        $this->load->view('admin/controller/footer');
    }
    public function deleted()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/index2', $data);
        $this->load->view('admin/controller/footer');
    }
    public function product_id()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";

        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/product_id', $data);
        $this->load->view('admin/controller/footer');
    }
    public function get_addfrm()
    {
        $this->General_model->auth_check();
        $data['page_title'] = "Quatation";
        $data["customer"] = $this->General_model->get_data('customer', 'status', '*', '1');

        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');
        $data["invoice_no"] = $this->SaleModel->invoice_no();

        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/create', $data);
        $this->load->view('admin/controller/footer');
    }
    public function updatestatus()
    {
        $quote = $this->input->post("quote");
        $orderstatus = $this->input->post("orderstatus");

        if (isset($quote) && !empty($quote) && isset($orderstatus) && !empty($orderstatus)) {

            $data = [
                'orderstatus' => $orderstatus,
                'modify_at' => date("Y-m-d h:i:s")
            ];
            $this->General_model->update('sale', $data, 'id_sale', $quote);
            $data['status'] = "success";
            $data['msg'] = "OrderStatus update";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function create()
    {
        $this->General_model->auth_check();

        $date = $this->input->post("date");
        $date = explode("/", $date);
        $date = [$date[2], $date[1], $date[0]];
        $date = implode("-", $date);

        $customer_id = $this->input->post("customer_id");
        $customer_name = $this->db->query("select name from customer where id_customer='$customer_id'")->row()->name;
        $site_manager = $this->input->post("site_manager");
        $invoice_no = $this->input->post("invoice_no");
        $unit = $this->input->post("unit");
        $vehicle_no = $this->input->post("vehicle_no");
        $remark = trim(ucwords($this->input->post("remark")));

        $sub_total = $this->input->post("sub_total");
        $discount = '0';
        $other_charge = $this->input->post("other_charge");
        $loading = $this->input->post("loading");
        $unloading = $this->input->post("unloading");
        $insurance = $this->input->post("insurance");
        $orderstatus = $this->input->post("orderstatus");
        $gst = $this->input->post("gst");

        $round_off = '0';
        $g_total = $this->input->post("g_total");
        $deposit = $this->input->post("deposit");

        $c_cut_foot = array_sum($this->input->post("c_foot"));
        $m_cut_foot = array_sum($this->input->post("m_foot"));
        $c_cut_total = array_sum($this->input->post("c_amount"));
        $m_cut_total = array_sum($this->input->post("m_amount"));
        if (isset($date) && !empty($date)  &&  isset($g_total) && !empty($g_total)) {
            $i = 0;
            $slug = $this->SaleModel->slug();
            $sale = [
                'date' => $date,
                'invoice_no' => $invoice_no,
                'unit' => $unit,
                'slug' => $slug,
                'customer_name' => $customer_name,
                'site_manager' => $site_manager,
                'vehicle_no' => $vehicle_no,
                'customer_id' => $customer_id,
                'sub_total' => $sub_total,
                'total_cut_foot' => $c_cut_foot,
                'total_molding_foot' => $m_cut_foot,
                'total_cutting_amout' => $c_cut_total,
                'total_molding_amout' => $m_cut_total,
                'discount' => $discount,
                'other_charge' => $other_charge,
                'loading' => $loading,
                'unloading' => $unloading,
                'insurance' => $insurance,
                'orderstatus' => $orderstatus,
                'gst' => $gst,
                'round_off' => $round_off,
                'g_total' => $g_total,
                'deposit' => $deposit,
                'remark' => $remark,
                'created_at' => date("Y-m-d h:i:s")
            ];
            $id = $this->General_model->addid('sale', $sale);

            foreach ($this->input->post("c_product_id") as $pr) {
                $product_id = $this->input->post("c_product_id")[$i];
                $c_length = $this->input->post("c_length")[$i];
                $c_width = $this->input->post("c_width")[$i];
                $c_quantity = $this->input->post("c_quantity")[$i];
                $c_foot = $this->input->post("c_foot")[$i];
                $c_rate = $this->input->post("c_rate")[$i];
                $c_amount = $this->input->post("c_amount")[$i];
                $sr_no = $this->input->post("sr_no")[$i];
                if (!empty($product_id) && !empty($c_quantity) && !empty($c_rate) && !empty($c_amount)) {
                    $product = [
                        'sale_id' => $id,
                        'product_id' => $product_id,
                        'sr_no' => $sr_no,
                        'cutting_molding' => 0,
                        'cut_type' => "-",
                        'side' => "-",
                        'length' => $c_length,
                        'width' => $c_width,
                        'foot' => $c_foot,
                        'price' => $c_rate,
                        'qty' => $c_quantity,
                        'total' => $c_amount,
                        'created_at' => date("Y-m-d h:i:s")
                    ];
                    $SALE__id = $this->General_model->addid('sale_product', $product);
                }
                $i++;
            }
            $j =  0;
            if ($this->input->post("m_product_id")) {
                foreach ($this->input->post("m_product_id") as $product_id) {
                    $product_id = $this->input->post("m_product_id")[$j];
                    $mcut_type = $this->input->post("mcut_type")[$j];
                    $mcut_side = $this->input->post("mcut_side")[$j];
                    $m_quantity = $this->input->post("m_quantity")[$j];
                    $m_length = $this->input->post("m_length")[$j];
                    $m_width = $this->input->post("m_width")[$j];
                    $m_foot = $this->input->post("m_foot")[$j];
                    $m_rate = $this->input->post("m_rate")[$j];
                    $m_amount = $this->input->post("m_amount")[$j];
                    $m_sr_no = $this->input->post("m_sr_no")[$j];

                    if (!empty($product_id) && !empty($m_quantity) && !empty($m_length) && !empty($m_width)) {
                        $product = [
                            'sale_id' => $id,
                            'product_id' => $product_id,
                            'cutting_molding' => 1,
                            'molding_sr_no' => $m_sr_no,
                            'cut_type' => $mcut_type,
                            'side' => $mcut_side,
                            'length' => $m_length,
                            'width' => $m_width,
                            'foot' => $m_foot,
                            'price' => $m_rate,
                            'qty' => $m_quantity,
                            'total' => $m_amount,
                            'created_at' => date("Y-m-d h:i:s")
                        ];
                        $this->db->insert('sale_product', $product);
                    }
                    $j++;
                }
            }
            $k = 0;
            if ($this->input->post("oProduct")) {

                foreach ($this->input->post("oProduct") as $product_id) {

                    $oAmount = $this->input->post("oAmount")[$k];

                    if (!empty($product_id) && !empty($oAmount)) {

                        $product = [
                            'sale_id' => $id,
                            'product_id' => $product_id,
                            'total' => $oAmount,
                            'created_at' => date("Y-m-d h:i:s")
                        ];
                        $this->db->insert('sale_other_product', $product);
                    }
                    $k++;
                }
            }

            $sess_data = [
                'status'  => 'success',
                'msg'  => 'Quote Added'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        } else {
            $sess_data = [
                'status'  => 'error',
                'msg'  => 'Something Is Worng'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        }
    }
    public function getLists($cur_year)
    {
        $columns = array(
            0 => 'id_sale ',
            1 => 'invoice_no',
            2 => 'date',
            3 => 'customer_name',
            4 => 'g_total',
            5 => 'unit'
        );
        $limit = $this->input->post('length');

        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->SaleModel->allposts_count($cur_year);
        $totalFiltered = $totalData;
        $length = $_POST['length']; // Get the length parameter sent by DataTables
        
        if ($length == -1) {
            $length = 1000000; // Set a large number or omit the LIMIT clause
        }
        
       
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->SaleModel->allposts($length, $start, $order, $dir,$cur_year);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->SaleModel->posts_search($length, $start, $search, $order, $dir,$cur_year);
            $totalFiltered = $this->SaleModel->posts_search_count($search,$cur_year);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['unit'] = $post->unit;
                $nestedData['order_status'] = ($post->orderstatus == 1) ? "Confirm" : "Pending";
                $nestedData['button'] = '
		         <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-pencil" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Slip/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-clipboard" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Challan/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-sliders" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/ChallanView/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light">view</button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getListsWithDelete()
    {
        $columns = array(
            0 => 'id_sale ',
            1 => 'invoice_no',
            2 => 'date',
            3 => 'customer_name',
            4 => 'g_total',
            5 => 'unit'
        );
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->SaleModel->allposts_dcount();
        $totalFiltered = $totalData;
        $length = $_POST['length']; // Get the length parameter sent by DataTables
        
        if ($length == -1) {
            $length = 1000000; // Set a large number or omit the LIMIT clause
        }
        
       
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->SaleModel->allpostsd($length, $start, $order, $dir);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->SaleModel->posts_search($length, $start, $search, $order, $dir);
            $totalFiltered = $this->SaleModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['unit'] = $post->unit;
                $nestedData['order_status'] = ($post->orderstatus == 1) ? "Confirm" : "Pending";
                $nestedData['button'] = '
		         <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-pencil" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Slip/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-clipboard" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Challan/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-sliders" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/ChallanView/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light">view</button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getListsPending()
    {
        $columns = array(
            0 => 'id_sale ',
            1 => 'invoice_no',
            2 => 'date',
            3 => 'customer_name',
            4 => 'g_total',
            5 => 'unit'
        );
        $status = 0;
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->SaleModel->allposts_count_status($status);
        $totalFiltered = $totalData;
        $length = $_POST['length']; // Get the length parameter sent by DataTables
        
        if ($length == -1) {
            $length = 1000000; // Set a large number or omit the LIMIT clause
        }
        
       
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->SaleModel->allposts_status($length, $start, $order, $dir,$status);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->SaleModel->posts_search_status($length, $start, $search, $order, $dir,$status);
            $totalFiltered = $this->SaleModel->posts_search_count_status($search,$status);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['unit'] = $post->unit;
                $nestedData['order_status'] = ($post->orderstatus == 1) ? "Confirm" : "Pending";
                $nestedData['button'] = '
		         <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-pencil" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Slip/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-clipboard" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Challan/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-sliders" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/ChallanView/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light">view</button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getListsConfirm()
    {
        $columns = array(
            0 => 'id_sale ',
            1 => 'invoice_no',
            2 => 'date',
            3 => 'customer_name',
            4 => 'g_total',
            5 => 'unit'
        );
        $status = '1';
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = count($this->General_model->get_data('sale','orderstatus','*',$status));
        $totalFiltered = $totalData;
        $length = $_POST['length']; // Get the length parameter sent by DataTables
        
        if ($length == -1) {
            $length = 1000000; // Set a large number or omit the LIMIT clause
        }
        
       
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->SaleModel->allposts_status($length, $start, $order, $dir,$status);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->SaleModel->posts_search_status($length, $start, $search, $order, $dir,$status);
            $totalFiltered = $this->SaleModel->posts_search_count_status($search,$status);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['unit'] = $post->unit;
                $nestedData['order_status'] = ($post->orderstatus == 1) ? "Confirm" : "Pending";
                $nestedData['button'] = '
		         <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-pencil" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Slip/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa  fa-clipboard" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Challan/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-sliders" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/ChallanView/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light">view</button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getLists1($id)
    {
        $columns = array(
            0 => 'sale_id',
            1 => 'product_name',
            2 => 'date',
            3 => 'price',
            4 => 'qty',
            5 => 'total',
            6 => 'gtotal',
        );

        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->SaleModel->allposts_count1($id);
        $totalFiltered = $totalData;
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->SaleModel->allposts1($limit, $start, $order, $dir, $id);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->SaleModel->posts_search($limit, $start, $search, $order, $dir);
            $totalFiltered = $this->SaleModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $nestedData['sr_no'] = $post->invoice_no;
                $nestedData['product_name'] = $post->product_name;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['price'] = $post->price;
                $nestedData['qty'] = $post->qty;
                $nestedData['total'] = number_format($post->total, 2);
                $nestedData['gtotal'] = number_format($post->gtotal, 2);
                $nestedData['button'] = '
		        <a href="' . base_url('Sale/get_editfrm/') . $post->sale_id . '"><button type="button" class="btn btn-primary btn-sm waves-effect waves-light"><i class="fa fa-edit" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Invoice/') . $post->sale_id . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->sale_id . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function getLists2($id)
    {
        $columns = array(
            0 => 'id_sale ',
            1 => 'bill_type',
            2 => 'invoice_no',
            3 => 'date',
            4 => 'customer_name',
            5 => 'g_total',
            6 => 'jama',
            7 => 'baki',
        );
        $limit = $this->input->post('length');
        $start = $this->input->post('start');
        $order = $columns[$this->input->post('order')[0]['column']];
        $dir = $this->input->post('order')[0]['dir'];
        $totalData = $this->PurchaseModel->allposts_count();
        $totalFiltered = $totalData;
        if (empty($this->input->post('search')['value'])) {
            $posts = $this->PurchaseModel->allposts2($limit, $start, $order, $dir, $id);
        } else {
            $search = $this->input->post('search')['value'];
            $posts =  $this->PurchaseModel->posts_search($limit, $start, $search, $order, $dir);
            $totalFiltered = $this->PurchaseModel->posts_search_count($search);
        }
        $data = array();
        if (!empty($posts)) {
            $i = 1;
            foreach ($posts as $post) {
                $customer_name = ((isset($post->customer_name2) && !empty($post->customer_name2)) ? $post->customer_name2 : $post->customer_name);
                $bill_type = (($post->bill_type == "1") ? "Cash" : "Debit");
                $nestedData['sr_no'] = $i;
                $nestedData['invoice_no'] = $post->invoice_no;
                $nestedData['date'] = date('d/m/Y', strtotime($post->date));
                $nestedData['bill_type'] = $bill_type;
                $nestedData['customer_name'] = $customer_name;
                $nestedData['g_total'] = number_format($post->g_total, 2);
                $nestedData['jama'] = number_format($post->jama, 2);
                $nestedData['baki'] = number_format($post->baki, 2);
                $nestedData['button'] = '
		        <a href="' . base_url('Sale/get_editfrm/') . $post->id_sale . '"><button type="button" class="btn btn-primary btn-sm waves-effect waves-light"><i class="fa fa-edit" aria-hidden="true"></i></button></a>
		        <a href="' . base_url('Sale/Invoice/') . $post->id_sale . '"><button type="button" class="btn btn-info btn-sm waves-effect waves-light"><i class="fa fa-eye" aria-hidden="true"></i></button></a>
		        <button type="button" class="btn btn-danger btn-sm waves-effect waves-light" data-id="delete" data-value="' . $post->id_sale . '"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                $data[] = $nestedData;
                $i++;
            }
        }
        $json_data = array(
            "draw"            => intval($this->input->post('draw')),
            "recordsTotal"    => intval($totalData),
            "recordsFiltered" => intval($totalFiltered),
            "data"            => $data
        );
        echo json_encode($json_data);
    }
    public function get_editfrm($id)
    {
        $this->General_model->auth_check();
        $data["customer"] = $this->General_model->get_all('customer');
        $data['sale'] = $this->General_model->get_row('sale', 'id_sale', $id);
        $sale_product = $this->General_model->get_data('sale_product', 'sale_id', '*', $id);
        $i = 1;
        foreach ($sale_product as $key => $value) {
            if ($i == 1) {
                $produtids[] = "product_id != '" . $value->product_id . "'";
            } else {
                $produtids[] = "and product_id != '" . $value->product_id . "'";
            }
            $i++;
        }
        $notselect_id = implode(" ", $produtids);
        //	$data["product"]=$this->db->query("SELECT * FROM `product` WHERE ".$notselect_id)->result(); 
        $data["product"] = $this->General_model->get_data('product', 'status', '*', '1');

        $data['sale_product'] = $this->db->query("SELECT t1.*,t2.product_name,t2.type,t2.qty as product_qty,(t1.qty+t2.qty) as total_qty  FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "' and t1.cutting_molding=0")->result();
        $data['page_title'] = "Quatation";
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/edit', $data);
        $this->load->view('admin/controller/footer');
    }
    public function update()
    {
        $this->General_model->auth_check();

        $date = $this->input->post("date");
        $date = explode("/", $date);
        $date = [$date[2], $date[1], $date[0]];
        $date = implode("-", $date);

        $customer_id = $this->input->post("customer_id");
        $customer_name = $this->db->query("select name from customer where id_customer='$customer_id'")->row()->name;
        $site_manager = $this->input->post("site_manager");
        $invoice_no = $this->input->post("invoice_no");
        $unit = $this->input->post("unit");
        $vehicle_no = $this->input->post("vehicle_no");
        $remark = trim(ucwords($this->input->post("remark")));
        $id_sale = $this->input->post("id_sale");
        $sub_total = $this->input->post("sub_total");
        $discount = '0';
        $other_charge = $this->input->post("other_charge");
        $gst = $this->input->post("gst");
        $round_off = '0';
        $g_total = $this->input->post("g_total");
        $deposit = $this->input->post("deposit");

        $c_cut_foot = array_sum($this->input->post("c_foot"));
        $m_cut_foot = is_array($this->input->post("m_foot")) ? array_sum($this->input->post("m_foot")) : null;
        $c_cut_total = array_sum($this->input->post("c_amount"));
        $m_cut_total = is_array($this->input->post("m_amount")) ? array_sum($this->input->post("m_amount")) : null;
        if (isset($date) && !empty($date)  &&  isset($g_total) && !empty($g_total)) {
            $i = 0;
            $slug = $this->SaleModel->slug();
            $sale = [
                'date' => $date,
                'invoice_no' => $invoice_no,
                'unit' => $unit,
                'slug' => $slug,
                'customer_name' => $customer_name,
                'site_manager' => $site_manager,
                'vehicle_no' => $vehicle_no,
                'customer_id' => $customer_id,
                'sub_total' => $sub_total,
                'total_cut_foot' => $c_cut_foot,
                'total_molding_foot' => $m_cut_foot,
                'total_cutting_amout' => $c_cut_total,
                'total_molding_amout' => $m_cut_total,
                'discount' => $discount,
                'other_charge' => $other_charge,
                'gst' => $gst,
                'round_off' => $round_off,
                'g_total' => $g_total,
                'deposit' => $deposit,
                'remark' => $remark,
                'created_at' => date("Y-m-d h:i:s")
            ];
            $this->General_model->update('sale', $sale, 'id_sale', $id_sale);

            $this->General_model->delete('sale_product', 'sale_id', $id_sale);

            foreach ($this->input->post("c_product_id") as $pr) {
                $product_id = $this->input->post("c_product_id")[$i];
                $c_length = $this->input->post("c_length")[$i];
                $c_width = $this->input->post("c_width")[$i];
                $c_quantity = $this->input->post("c_quantity")[$i];
                $c_foot = $this->input->post("c_foot")[$i];
                $c_rate = $this->input->post("c_rate")[$i];
                $c_amount = $this->input->post("c_amount")[$i];
                $sr_no = $this->input->post("sr_no")[$i];
                if (!empty($product_id) && !empty($c_quantity) && !empty($c_rate) && !empty($c_amount)) {
                    $product = [
                        'sale_id' => $id_sale,
                        'product_id' => $product_id,
                        'sr_no' => $sr_no,
                        'cutting_molding' => 0,
                        'cut_type' => "-",
                        'side' => "-",
                        'length' => $c_length,
                        'width' => $c_width,
                        'foot' => $c_foot,
                        'price' => $c_rate,
                        'qty' => $c_quantity,
                        'total' => $c_amount,
                        'created_at' => date("Y-m-d h:i:s")
                    ];
                    $SALE__id = $this->General_model->addid('sale_product', $product);
                }
                $i++;
            }
            $j =  0;
            if ($this->input->post("m_product_id")) {
                foreach ($this->input->post("m_product_id") as $product_id) {
                    $product_id = $this->input->post("m_product_id")[$j];
                    $mcut_type = $this->input->post("mcut_type")[$j];
                    $mcut_side = $this->input->post("mcut_side")[$j];
                    $m_quantity = $this->input->post("m_quantity")[$j];
                    $m_length = $this->input->post("m_length")[$j];
                    $m_width = $this->input->post("m_width")[$j];
                    $m_foot = $this->input->post("m_foot")[$j];
                    $m_rate = $this->input->post("m_rate")[$j];
                    $m_amount = $this->input->post("m_amount")[$j];
                    $m_sr_no = $this->input->post("m_sr_no")[$j];

                    if (!empty($product_id) && !empty($m_quantity) && !empty($m_length) && !empty($m_width)) {
                        $product = [
                            'sale_id' => $id_sale,
                            'product_id' => $product_id,
                            'cutting_molding' => 1,
                            'molding_sr_no' => $m_sr_no,
                            'cut_type' => $mcut_type,
                            'side' => $mcut_side,
                            'length' => $m_length,
                            'width' => $m_width,
                            'foot' => $m_foot,
                            'price' => $m_rate,
                            'qty' => $m_quantity,
                            'total' => $m_amount,
                            'created_at' => date("Y-m-d h:i:s")
                        ];
                        $this->db->insert('sale_product', $product);
                    }
                    $j++;
                }
            }

            $sess_data = [
                'status'  => 'success',
                'msg'  => 'Update  Successfully'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        } else {
            $sess_data = [
                'status'  => 'error',
                'msg'  => 'Something Is Worng'
            ];
            $this->session->set_userdata($sess_data);
            redirect(base_url('Sale'));
        }
    }
    public function Slip($id)
    {
        $data['page_title'] = "Invoice";
        $data['sale'] = $this->db->query("SELECT t1.*,t2.name as customer_name2,t2.mobile as mobile_no FROM sale as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id_sale='" . $id . "'")->row();
        $data['cutting_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name,t2.product_id FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "' and t1.cutting_molding=0")->result();
        $data['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name,t2.product_id FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'  and t1.cutting_molding=1")->result();
        $data['molding_sale_other_product'] = $this->db->query("SELECT * FROM sale_other_product WHERE sale_id='" . $id . "' ")->result();

        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/invoice', $data);
        $this->load->view('admin/controller/footer');
    }

    public function Challan($id)
    {
        $data['page_title'] = "Invoice";
        $data['sale'] = $this->db->query("SELECT t1.*,t2.name as customer_name2,t2.mobile as mobile_no FROM sale as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id_sale='" . $id . "'")->row();
        $data['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name,t2.product_id FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'  and t1.cutting_molding=1")->result();
        $data['molding_sale_other_product'] = $this->db->query("SELECT * FROM sale_other_product WHERE sale_id='" . $id . "' ")->result();
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/challan-copy', $data);
        $this->load->view('admin/controller/footer');
    }

    public function ChallanView($id)
    {
        $data['page_title'] = "Invoice";
        $data['sale'] = $this->db->query("SELECT t1.*,t2.name as customer_name2,t2.mobile as mobile_no FROM sale as t1 LEFT JOIN customer as t2 ON t1.customer_id=t2.id_customer WHERE t1.id_sale='" . $id . "'")->row();
        $data['cutting_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "' and t1.cutting_molding=0")->result();
        $data['molding_sale_product'] = $this->db->query("SELECT t1.*,t2.product_name FROM sale_product as t1 LEFT JOIN product as t2 ON t1.product_id=t2.product_id WHERE t1.sale_id='" . $id . "'  and t1.cutting_molding=1")->result();
        $data['molding_sale_other_product'] = $this->db->query("SELECT * FROM sale_other_product WHERE sale_id='" . $id . "' ")->result();
        $this->load->view('admin/controller/header');
        $this->load->view('admin/controller/sidebar');
        $this->load->view('admin/sale/challanview', $data);
        $this->load->view('admin/controller/footer');
    }

    public function delete($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $sale_id =  $this->General_model->get_row('sale', 'id_sale', $id);
            $update = ['status'=>'0'];
            $this->General_model->delete('sale_payment', 'sale_id', $id);
            $this->General_model->update('sale',$update, 'id_sale', $id);
            $data['status'] = "success";
            $data['msg'] = "Purchase Detail Deleted";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
    public function deleterow($id)
    {
        $this->General_model->auth_check();
        if (isset($id) && !empty($id)) {
            $sale_product = $this->General_model->get_data('sale_product', 'id_saleproduct', '*', $id);
            foreach ($sale_product as $key => $value) {
                $prouctQty = $this->General_model->get_row('product', 'product_id', $value->product_id);
                $product_qty = $prouctQty->qty;
                $product_qty = $product_qty + $value->qty;
                $this->General_model->update('product', ['qty' => $product_qty], 'product_id', $value->product_id);
            }
            $this->General_model->delete('sale_product', 'id_saleproduct', $id);
            $data['status'] = "success";
            $data['msg'] = "Purchase Detail Deleted";
        } else {
            $data['status'] = "error";
            $data['msg'] = "Something is Worng";
        }
        echo json_encode($data);
    }
}
