<?php
class PaymentModel extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }
    function allposts_count()
    {
        $this->db->select('t1.*,t2.name as customer_name');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        $this->db->where('t1.status', '1');
        $query = $this->db->get('sale_payment as t1');
        return $query->num_rows();
    }
    function allposts($limit, $start, $col, $dir)
    {
        $this->db->select('t1.*,t2.name as customer_name');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        $this->db->where('t1.status', '1');
        $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('sale_payment as t1');
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function posts_search($limit, $start, $search, $col, $dir)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name')->from('sale_payment as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.date', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.rs', $search)
            ->or_like('t1.remark', $search)
            ->group_end()
            ->where('t1.status', '1')
            ->limit($limit, $start)
            ->order_by($col, $dir)
            ->get();
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function posts_search_count($search)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name')->from('sale_payment as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.date', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.rs', $search)
            ->or_like('t1.remark', $search)
            ->group_end()
            ->where('t1.status', '1')
            ->get();
        return $query->num_rows();
    }
}
