<?php
class PurchaseModel extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }
    function allposts_count()
    {
        $this->db->select('t1.*,t2.slug,t2.date,t3.product_name,t2.invoice_no,t3.box,t2.remark');
        $this->db->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $query = $this->db->get('purchase_product as t1');
        return $query->num_rows();
    }
    function allposts_count1($id)
    {
        $this->db->select('t1.*,t2.slug,t2.date,t2.invoice_no,t3.product_name,t3.box,t2.remark');
        $this->db->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $this->db->where('t3.product_id', $id);
        $query = $this->db->get('purchase_product as t1');
        return $query->num_rows();
    }
    function allposts($limit, $start, $col, $dir)
    {
        $this->db->select('t1.*,t2.slug,t2.date,t2.invoice_no,t3.product_name,t3.box,t2.remark');
        $this->db->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('purchase_product as t1');
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function allposts2($limit, $start, $col, $dir, $id)
    {
        $this->db->select('t1.*,t2.slug,t2.date,t2.invoice_no,t3.product_name,t3.box,t2.remark');
        $this->db->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $this->db->where('t3.product_id', $id);
        $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('purchase_product as t1');
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function posts_search($limit, $start, $search, $col, $dir)
    {
        $query = $this->db->select('t1.*,t2.slug,t2.invoice_no,t2.date,t3.product_name,t3.box,t2.remark')->from('purchase_product as t1')
            ->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left')
            ->join('product as t3', 't1.product_id = t3.product_id', 'left')
            ->group_start()
            ->like('t3.product_name', $search)
            ->or_like('t2.invoice_no', $search)
            ->or_like('t3.box', $search)
            ->or_like('t2.remark', $search)
            ->or_like('t2.date', $search)
            ->or_like('t1.price', $search)
            ->or_like('t1.qty', $search)
            ->or_like('t1.total', $search)
            ->group_end()
            ->limit($limit, $start)
            ->order_by($col, $dir)
            ->get();
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function posts_search_count($search)
    {
        $query = $this->db->select('t1.*,t2.slug,t2.date,t3.product_name,t2.invoice_no,t3.box,t2.remark')->from('purchase_product as t1')
            ->join('purchase as t2', 't1.purchase_id = t2.purchase_id', 'left')
            ->join('product as t3', 't1.product_id = t3.product_id', 'left')
            ->group_start()
            ->like('t3.product_name', $search)
            ->or_like('t2.invoice_no', $search)
            ->or_like('t3.box', $search)
            ->or_like('t2.date', $search)
            ->or_like('t2.remark', $search)
            ->or_like('t1.price', $search)
            ->or_like('t1.qty', $search)
            ->or_like('t1.total', $search)
            ->group_end()
            ->get();
        return $query->num_rows();
    }
    public function slug()
    {
        $slug = $this->random_slug(15);
        $product = $this->db->select('*')
            ->where('slug', $slug)
            ->get('purchase')
            ->num_rows();
        if ($product > 0) {
            $this->slug();
        } else {
            return $slug;
        }
    }
    protected function random_slug($length)
    {
        $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $string = [];
        $alpha_length = strlen($alphabet) - 1;
        for ($i = 0; $i < $length; $i++) {
            $n = rand(0, $alpha_length);
            $string[] = $alphabet[$n];
        }
        return implode($string);
    }
    public function invoice_no()
    {
        $query = $this->db->select('invoice_no')->from('purchase')
            ->order_by('purchase_id', "DESC")
            ->limit('1')
            ->get();
        $count = $query->num_rows();
        if ($count > 0) {
            $result = $query->row();
            $result = ['invoice_no' => $result->invoice_no + 1];
            return $result;
        } else {
            $result = ['invoice_no' => 1];
            return $result;
        }
    }
}
