<?php
class SaleModel extends CI_Model
{
    function __construct()
    {
        parent::__construct();
    }
    function allposts_count($year)
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        $query = $this->db->get('sale as t1');
        $this->db->where('t1.status','1');
              $this->db->where('t1.cur_year',$year);
        return $query->num_rows();
    }
    function allposts_dcount()
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        $query = $this->db->get('sale as t1');
        $this->db->where('t1.status','0');
        return $query->num_rows();
    }
    function allposts_count_status($status)
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        $query = $this->db->get('sale as t1');
        $this->db->where('t1.status','1');
        $this->db->where('t1.orderstatus',$status);
      
        return $query->num_rows();
    }
    function allposts_count1($id)
    {
        $this->db->select('t1.*,t2.slug,t2.date,t2.invoice_no,t3.product_name,t3.box,t2.remark');
        $this->db->join('sale as t2', 't1.sale_id = t2.id_sale', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $this->db->where('t3.product_id', $id);
        $this->db->where('t2.status','1');
        $query = $this->db->get('sale_product as t1');
        return $query->num_rows();
    }
    function allposts($limit, $start, $col, $dir,$year)
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        if ($_SESSION['auth_role_id'] == '2') {
            $this->db->where('t1.unit', "moonlight marble");
        }
       $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('sale as t1');
       $this->db->where('t1.status','1');
         $this->db->where('t1.cur_year',$year);
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function allpostsd($limit, $start, $col, $dir)
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        if ($_SESSION['auth_role_id'] == '2') {
            $this->db->where('t1.unit', "moonlight marble");
        }
       $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('sale as t1');
       $this->db->where('t1.status','0');
        
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function allposts_status($limit, $start, $col, $dir, $status)
    {
        $this->db->select('t1.*,t2.name as customer_name2');
        $this->db->join('customer as t2', 't1.customer_id = t2.id_customer', 'left');
        if ($_SESSION['auth_role_id'] == '2') {
            $this->db->where('t1.unit', "moonlight marble");
        }
       $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('sale as t1');
       $this->db->where('t1.status','1');

       $this->db->where('t1.orderstatus',$status);
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }

    function allposts1($limit, $start, $col, $dir, $id)
    {
        $this->db->select('t1.*,t2.slug,t2.date,t2.invoice_no,t3.product_name,t3.box,t2.remark');
        $this->db->join('sale as t2', 't1.sale_id = t2.id_sale', 'left');
        $this->db->join('product as t3', 't1.product_id = t3.product_id', 'left');
        $this->db->where('t3.product_id', $id);
        if ($_SESSION['auth_role_id'] == '1') {
            $this->db->where('t2.unit', "moonligh marble");
        }
        $query = $this->db->limit($limit, $start)->order_by($col, $dir)->get('sale_product as t1');
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }

    function posts_search($limit, $start, $search, $col, $dir,$year)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name2')->from('sale as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.invoice_no', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.date', $search)
            ->or_like('t1.unit', $search)
            ->or_like('t1.customer_name', $search)
            ->or_like('t1.g_total', $search)
            ->group_end()
            ->limit($limit, $start)
            ->where('t1.cur_year',$year)
            ->order_by($col, $dir)
            ->get();
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }



    function posts_search_status($limit, $start, $search, $col, $dir)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name2')->from('sale as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.invoice_no', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.date', $search)
            ->or_like('t1.unit', $search)
            ->or_like('t1.customer_name', $search)
            ->or_like('t1.g_total', $search)
            ->group_end()
            ->limit($limit, $start)
            ->order_by($col, $dir)
            ->get();
        if ($query->num_rows() > 0) {
            return $query->result();
        } else {
            return null;
        }
    }
    function posts_search_count_status($search,$status)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name2')->from('sale as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.invoice_no', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.date', $search)
            ->or_like('t1.unit', $search)
            ->or_like('t1.customer_name', $search)
            ->or_like('t1.g_total', $search)
            ->where('t1.orderstatus',$status)
            ->group_end()
            ->get();
        return $query->num_rows();
    }
    function posts_search_count($search)
    {
        $query = $this->db->select('t1.*,t2.name as customer_name2')->from('sale as t1')
            ->join('customer as t2', 't1.customer_id = t2.id_customer', 'left')
            ->group_start()
            ->like('t1.invoice_no', $search)
            ->or_like('t2.name', $search)
            ->or_like('t1.date', $search)
            ->or_like('t1.unit', $search)
            ->or_like('t1.customer_name', $search)
            ->or_like('t1.g_total', $search)
            ->group_end()
            ->get();
        return $query->num_rows();
    }
    public function slug()
    {
        $slug = $this->random_slug(15);
        $product = $this->db->select('*')
            ->where('slug', $slug)
            ->get('sale')
            ->num_rows();
        if ($product > 0) {
            $this->slug();
        } else {
            return $slug;
        }
    }
    protected function random_slug($length)
    {
        $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $string = [];
        $alpha_length = strlen($alphabet) - 1;
        for ($i = 0; $i < $length; $i++) {
            $n = rand(0, $alpha_length);
            $string[] = $alphabet[$n];
        }
        return implode($string);
    }
    public function invoice_no()
    {
        $query = $this->db->select('invoice_no')->from('sale')
            ->order_by('id_sale', "DESC")
            ->where('cur_year',2024)
            ->limit('1')
            ->get();
        $count = $query->num_rows();
        if ($count > 0) {
            $result = $query->row();
            $result = ['invoice_no' => $result->invoice_no + 1];
            return $result;
        } else {
            $result = ['invoice_no' => 1];
            return $result;
        }
    }
}
