<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-12">
                <div class="page-title-box">
                    <h4 class="page-title float-left"><?php echo $page_title; ?></h4>
                    <ol class="breadcrumb float-right">
                        <li class="breadcrumb-item"><a href="<?php echo base_url('dashbord'); ?>"><?php echo COMPANY; ?></a></li>
                        <li class="breadcrumb-item"><a href="<?php echo base_url('Payment/index'); ?>"><?php echo $page_title; ?></a></li>
                    </ol>
                    <div class="clearfix"></div>
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <div class="card-box">
                    <h4 class="header-title m-t-0 text-center m-b-30">Cutting Molding Report</h4>
                    <form role="form" method="post" action="<?php echo $action; ?>">
                        <div class="row">
                            <div class=" offset-md-3 col-md-6">
                                <div class="form-group row ">
                                    <label for="Date" class="col-3 col-form-label">Date<span class="text-danger">*</span></label>
                                    <div class="col-9">
                                        <?php $month = date('d/m/Y'); ?>
                                        <div class="input-daterange input-group" id="date-range">
                                            <input type="text" class="form-control" name="start" autocomplete="off" value="<?php echo (($method == "edit") ? $strt_date : $month); ?>" />
                                            <input type="text" class="form-control" name="end" autocomplete="off" value="<?php echo (($method == "edit") ? $end_date : date('d/m/Y')); ?>" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="form-group row m-t-20">
                            <div class="col-12 text-center">
                                <button type="submit" class="btn btn-primary waves-effect waves-light">
                                    Check
                                </button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <?php if ($display) : ?>
            <div class="row">
                <div class="col-md-12 table-responsive">
                    <div class="card-box">
                        <div class="text-left m-b-30">
                            <div class="col-md-12">
                                <div class="row">
                                    <div class="text-left font-weight-bold">
                                        From : &nbsp;&nbsp;
                                    </div>
                                    <div class="text-right">
                                        <?php echo $strt_date . ' To ' . $end_date; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row ">

                            <div class="col-md-12 table-responsive">
                                <table class="table table-bordered" width="100%">
                                    <thead>
                                        <tr>
                                            <th scope="col" colspan="4" class="text-center">SALE</th>
                                        </tr>
                                        <tr>
                                            <th scope="col" class="text-center">Customer</th>
                                            <th scope="col" class="text-center">Challan No</th>
                                            <th scope="col" class="text-center">DATE</th>
                                            <th scope="col" class="text-center">Cutting Foot</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <?php if (isset($cutting) && !empty($cutting)) :
                                            $debit_cut  = 0;
                                            foreach ($cutting as $debit) : ?>
                                                <tr>

                                                    <td class="text-center"><?php echo ucwords($debit->customer_name); ?></td>
                                                    <td class="text-center"><?php echo ucwords($debit->invoice_no); ?></td>
                                                    <td class="text-center"><?php echo date('d/m/Y', strtotime($debit->date));  ?></td>
                                                    <td class="text-center"><?php echo $debit->total_cut_foot; ?></td>
                                                    <?php $debit_cut = $debit_cut + $debit->total_cut_foot; ?>
                                                </tr>
                                            <?php endforeach; ?>
                                            <tr>
                                                <th class="text-center" colspan="3">TOTAL</th>
                                                <th class="text-center"><?= number_format($debit_cut, 2); ?></th>
                                            </tr>
                                        <?php endif; ?>
                                    </tbody>
                                </table>
                            </div>
                            <div class="col-md-12 table-responsive">
                                <table class="table table-bordered" width="100%">
                                    <thead>
                                        <tr>
                                            <th scope="col" colspan="4" class="text-center">Molding Report
                                            </th>
                                        </tr>
                                        <tr>
                                            <th scope="col" class="text-center">Customer</th>
                                            <th scope="col" class="text-center">Challan No</th>
                                            <th scope="col" class="text-center">DATE</th>
                                            <th scope="col" class="text-center">Molding Foot</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                    <tbody>
                                        <?php if (isset($molding) && !empty($molding)) :
                                            $debit_cut2  = 0;
                                            foreach ($molding as $debit) : ?>
                                                <tr>

                                                    <td class="text-center"><?php echo ucwords($debit->customer_name); ?></td>
                                                    <td class="text-center"><?php echo ucwords($debit->invoice_no); ?></td>
                                                    <td class="text-center"><?php echo date('d/m/Y', strtotime($debit->date));  ?></td>
                                                    <td class="text-center"><?php echo $debit->total_molding_foot; ?></td>
                                                    <?php $debit_cut2 = $debit_cut2 + $debit->total_molding_foot; ?>
                                                </tr>
                                            <?php endforeach; ?>
                                            <tr>
                                                <th class="text-center" colspan="3">TOTAL</th>
                                                <th class="text-center"><?= number_format($debit_cut2, 2); ?></th>
                                            </tr>
                                        <?php endif; ?>
                                    </tbody>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
<script type="text/javascript">
    $(document).ready(function() {
        $('form').parsley();
        $("select").select2();
        jQuery('#date-range').datepicker({
            toggleActive: true,
            format: "dd/mm/yyyy"
        });
    });
</script>